\subsection{Isomorphisms}

> module Iso where

Some isomorphisms.

> data Iso a b = Iso {to :: a -> b, from :: b -> a}
> 
> assocIso :: Iso ((a,b),c) (a,(b,c))
> assocIso = Iso (\((a,b),c) -> (a,(b,c))) (\(a,(b,c)) -> ((a,b),c))
>
> swapIso :: Iso (a,b) (b,a)
> swapIso = Iso (\(a,b) -> (b,a)) (\(a,b) -> (b,a))
>
> unitlIso :: Iso a ((),a)
> unitlIso = Iso (\a -> ((),a)) (\((),a) -> a)
>
> unitrIso :: Iso a (a,())
> unitrIso = Iso (\a -> (a,())) (\(a,()) -> a)