\subsection{Relational BX}

> module RelBX where
> import Lens

pointed types that have a distinguished element

> class Pointed a where
>       point :: a

Relational bx

> data RelBX a b = RelBX {  consistent :: a -> b -> Bool,
>                           fwd :: a -> b -> b,
>                           bwd :: a -> b -> a}

Lenses from relational bx 

> lens2rel :: Eq b => Lens a b -> RelBX a b
> lens2rel l = RelBX  (\a b -> view l a == b)
>                     (\a b -> view l a)
>                     (\a b -> update l a b)

Relational BX form spans of lenses provided types pointed

> rel2lensSpan :: (Pointed a, Pointed b) => RelBX a b -> (Lens (a,b) a, Lens (a,b) b)
> rel2lensSpan bx = (  Lens  fst 
>                            (\(_,b) a -> (a,fwd bx a b)) 
>                            (\a -> (point,point)),
>                      Lens  snd 
>                            (\(a,_) b -> (bwd bx a b,b)) 
>                            (\b -> (point,point)))
